package dowry.hibernate;

import java.util.*;
import org.hibernate.mapping.Property;
import dowry.*;

/**
 * The HibernateType is a datatype with some added behavior
 * to work with the Hibernate entity mapper.
 *
 */
public interface HibernateType extends Datatype
{
	/**
	 * Generates a map of attributes for the specified
	 * Hibernate property, based on the rules of this
	 * datatype.
	 *
	 * @param entityMapper  a handle back to the entity
	 *                      mapper processing the Hibernate
	 *                      configuration
	 *
	 * @param property      the Hibernate property
	 *
	 * @return              a Map containing the relevant
	 *                      Dowry attributes
	 *
	 */
	public Map toConfiguration(HibernateEntityMapper entityMapper,
	                           Property property);
}