/*
 * Copyright 2005 Joe Walker
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.directwebremoting.extend;

/**
 * A WaitController allows the {@link ServerLoadMonitor} to know what is waiting
 * and enables it to tell them to stop waiting.
 * TODO: Change the name of this to something that indicates it's about shutdown
 * @author Joe Walker [joe at getahead dot ltd dot uk]
 */
public interface WaitController
{
    /**
     * Stop waiting - the server wants to shutdown
     */
    void shutdown();

    /**
     * @return Has {@link #shutdown()} been called?
     */
    boolean isShutdown();
}
